/*
 *  åѥ PIT(AT91SAM7Sѡ
 */

#include "kernel_impl.h"
#include "time_event.h"
#include <sil.h>
#include "target_timer.h"

#include <AT91SAM7S.h>

uint32_t __timer_counter = 0;

/*
 *  ޤεư
 */
void
target_timer_initialize(intptr_t exinf)
{
  uint32_t mr;

  // Initialize and enable the PIT
  // PIT.MR.PIV = [Hz]/16/1000[Hz]
  mr = ((F_CPU >> 4) / 1000) -1;
  sil_wrw_mem((void*)(TADR_PIT_BASE+TOFF_PIT_MR), mr);

  sil_wrw_mem((void*)(TADR_PMC_BASE+TOFF_PMC_PCER), (1<<INTNO_SYSIRQ_PID));

  mr |= PIT_PITEN;
  sil_wrw_mem((void*)(TADR_PIT_BASE+TOFF_PIT_MR), mr);

  // Set up timer interrupt
  // Enable the interrupt on the pit
  mr |= PIT_PITIEN;
  sil_wrw_mem((void*)(TADR_PIT_BASE+TOFF_PIT_MR), mr);

  // Enable the pit
  mr |= PIT_PITEN;
  sil_wrw_mem((void*)(TADR_PIT_BASE+TOFF_PIT_MR), mr);
}

/*
 *  ޤ߽
 */
void
target_timer_terminate(intptr_t exinf)
{
  uint32_t mr;

  // ڥǥ󥰥ӥåȤ򥯥ꥢ
  sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_EOICR), 0);

  // MRμ
  mr = sil_rew_mem((void *)(TADR_PIT_BASE+TOFF_PIT_MR));

  // 
  sil_wrw_mem((void*)(TADR_PIT_BASE+TOFF_PIT_MR), (mr & ~PIT_PITEN));

  // Ե
  sil_wrw_mem((void*)(TADR_PIT_BASE+TOFF_PIT_MR), (mr & ~PIT_PITIEN));
}

/*
 *  ޳ߥϥɥ
 */
void
target_timer_handler(intptr_t exno)
{
  uint32_t sr;
  uint32_t mr;

  // MRμ
  mr = sil_rew_mem((void *)(TADR_PIT_BASE+TOFF_PIT_MR));

  // pit
  if (mr & PIT_PITIEN) {
    sr = sil_rew_mem((void *)(TADR_PIT_BASE+TOFF_PIT_SR));
    if (sr & PIT_PITS) {
      sil_rew_mem((void *)(TADR_PIT_BASE+TOFF_PIT_PIVR));
      signal_time(); // ƥåζ
      __timer_counter++;
    }
  }
}

